unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    procedure TrackBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    TrackHint: THintWindow;
    procedure TrackHintSet(P: TPoint; s: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.TrackBar1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if not (Shift = [ssLeft]) then Exit;
  TrackHintSet(Point(X + TrackBar1.Left, TrackBar1.Top), IntToStr(TrackBar1.Position));
  TrackHint.Invalidate;
end;

procedure TForm1.TrackBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TrackHint.Free;
end;

procedure TForm1.TrackHintSet(P: TPoint; s: String);
var
  r: TRect;
begin
  r := TrackHint.CalcHintRect(100, s, nil);
  P.y := P.y - r.Bottom + r.Top;
  P.x := P.x - (r.Right - r.Left) div 2;
  P := ClientToScreen(P);
  TrackHint.SetBounds(P.x, P.y, r.Right - r.Left, r.Bottom - r.Top);
  TrackHint.Caption := s;
end;

procedure TForm1.TrackBar1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TrackHint := THintWindow.Create(Self);
  TrackHintSet(Point(X + TrackBar1.Left, TrackBar1.Top), IntToStr(TrackBar1.Position));
  TrackHint.Show;
end;

end.

